Index: /trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -55,5 +55,5 @@
 
   m_skipFlag           = NULL;
-#if NH_3D_DIS
+#if NH_3D
   m_bDISFlag           = NULL;
   m_ucDISType          = NULL;
@@ -99,10 +99,9 @@
   for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
   {
-    m_apcCUColocated[i]  = NULL;
     m_apiMVPIdx[i]       = NULL;
     m_apiMVPNum[i]       = NULL;
   }
 
-#if NH_3D_DMM
+#if NH_3D
   for( Int i = 0; i < NUM_DMM; i++ )
   {
@@ -111,6 +110,5 @@
   }
   m_dmm1WedgeTabIdx = NULL;
-#endif
-#if NH_3D_SDC_INTRA
+
   m_pbSDCFlag             = NULL;
   m_apSegmentDCOffset[0]  = NULL;
@@ -120,20 +118,10 @@
   m_bDecSubCu          = false;
 
-#if NH_3D_NBDV
+#if NH_3D
   m_pDvInfo              = NULL;
-#endif
-#if NH_3D_VSP
   m_piVSPFlag            = NULL;
-#endif
-#if NH_3D_SPIVMP
   m_pbSPIVMPFlag         = NULL;
-#endif
-#if NH_3D_ARP
   m_puhARPW              = NULL;
-#endif
-#if NH_3D_IC
   m_pbICFlag             = NULL;
-#endif
-#if NH_3D_DBBP
   m_pbDBBPFlag         = NULL;
 #endif
@@ -167,5 +155,5 @@
     m_ChromaQpAdj        = new UChar[ uiNumPartition ];
     m_skipFlag           = new Bool[ uiNumPartition ];
-#if NH_3D_DIS
+#if NH_3D
     m_bDISFlag           = new Bool[ uiNumPartition ];
     m_ucDISType          = (UChar*)xMalloc(UChar, uiNumPartition);
@@ -178,8 +166,6 @@
     m_pbMergeFlag        = (Bool*  )xMalloc(Bool,   uiNumPartition);
     m_puhMergeIndex      = (UChar* )xMalloc(UChar,  uiNumPartition);
-#if NH_3D_VSP
+#if NH_3D
     m_piVSPFlag          = (SChar* )xMalloc(SChar, uiNumPartition);
-#endif
-#if NH_3D_SPIVMP
     m_pbSPIVMPFlag       = (Bool*  )xMalloc(Bool,   uiNumPartition);
 #endif
@@ -201,5 +187,5 @@
     }
 
-#if NH_3D_NBDV 
+#if NH_3D
     m_pDvInfo            = (DisInfo* )xMalloc(DisInfo,  uiNumPartition);
 #endif
@@ -242,11 +228,7 @@
     }
 
-#if NH_3D_ARP
+#if NH_3D
     m_puhARPW            = (UChar*  )xMalloc(UChar,   uiNumPartition);
-#endif
-#if NH_3D_IC
     m_pbICFlag           = (Bool* )xMalloc(Bool,   uiNumPartition);
-#endif
-#if NH_3D_DMM
     for( Int i = 0; i < NUM_DMM; i++ )
     {
@@ -255,11 +237,7 @@
     }
     m_dmm1WedgeTabIdx    = (UInt*)xMalloc(UInt, uiNumPartition);
-#endif
-#if NH_3D_SDC_INTRA
     m_pbSDCFlag             = (Bool*)xMalloc(Bool, uiNumPartition);
     m_apSegmentDCOffset[0]  = (Pel*)xMalloc(Pel, uiNumPartition);
     m_apSegmentDCOffset[1]  = (Pel*)xMalloc(Pel, uiNumPartition);
-#endif
-#if NH_3D_DBBP
     m_pbDBBPFlag         = (Bool*  )xMalloc(Bool,   uiNumPartition);
 #endif
@@ -280,9 +258,4 @@
   m_pCtuAbove          = NULL;
   m_pCtuLeft           = NULL;
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = NULL;
-  }
 }
 
@@ -319,5 +292,5 @@
     }
 
-#if NH_3D_DIS
+#if NH_3D
     if ( m_bDISFlag           ) { delete[] m_bDISFlag;   m_bDISFlag     = NULL; }
     if ( m_ucDISType         ) { xFree(m_ucDISType);  m_ucDISType    = NULL; }
@@ -360,5 +333,5 @@
     }
 
-#if NH_3D_VSP
+#if NH_3D
     if ( m_piVSPFlag )
     {
@@ -366,6 +339,4 @@
       m_piVSPFlag = NULL;
     }
-#endif
-#if NH_3D_SPIVMP
     if ( m_pbSPIVMPFlag       ) { xFree(m_pbSPIVMPFlag);           m_pbSPIVMPFlag         = NULL; }
 #endif
@@ -455,17 +426,8 @@
       m_acCUMvField[rpl].destroy();
     }
-#if NH_3D_NBDV 
+#if NH_3D
     if ( m_pDvInfo            ) { xFree(m_pDvInfo);             m_pDvInfo           = NULL; }
-#endif
-
-
-#if NH_3D_ARP
     if ( m_puhARPW            ) { xFree(m_puhARPW);             m_puhARPW           = NULL; }
-#endif
-#if NH_3D_IC
     if ( m_pbICFlag           ) { xFree(m_pbICFlag);            m_pbICFlag          = NULL; }
-#endif
-
-#if NH_3D_DMM
     for( Int i = 0; i < NUM_DMM; i++ )
     {
@@ -474,12 +436,8 @@
     }
     if ( m_dmm1WedgeTabIdx    ) { xFree( m_dmm1WedgeTabIdx );  m_dmm1WedgeTabIdx = NULL;  }
-#endif
-#if NH_3D_SDC_INTRA
     if ( m_pbSDCFlag            ) { xFree(m_pbSDCFlag);             m_pbSDCFlag             = NULL; }
     if ( m_apSegmentDCOffset[0] ) { xFree(m_apSegmentDCOffset[0]);  m_apSegmentDCOffset[0]  = NULL; }
     if ( m_apSegmentDCOffset[1] ) { xFree(m_apSegmentDCOffset[1]);  m_apSegmentDCOffset[1]  = NULL; }
-#endif    
-#if NH_3D_DBBP
-    if ( m_pbDBBPFlag         ) { xFree(m_pbDBBPFlag);          m_pbDBBPFlag        = NULL; }
+    if ( m_pbDBBPFlag           ) { xFree(m_pbDBBPFlag);          m_pbDBBPFlag        = NULL; }
 #endif
 
@@ -493,10 +451,4 @@
   m_pCtuAbove          = NULL;
   m_pCtuLeft           = NULL;
-
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = NULL;
-  }
 
 }
@@ -572,5 +524,5 @@
   memset( m_skipFlag          , false,                      m_uiNumPartition * sizeof( *m_skipFlag ) );
 
-#if NH_3D_DIS
+#if NH_3D
     memset( m_bDISFlag        , false,                      m_uiNumPartition * sizeof( *m_bDISFlag ) );
     memset( m_ucDISType       , false,                      m_uiNumPartition * sizeof( *m_ucDISType ) );
@@ -585,5 +537,5 @@
   memset( m_puhHeight         , maxCUHeight,                m_uiNumPartition * sizeof( *m_puhHeight ) );
 
-#if NH_3D_IC
+#if NH_3D
   memset( m_pbICFlag          , false,                      m_uiNumPartition * sizeof( *m_pbICFlag ) );
 #endif
@@ -606,14 +558,8 @@
   memset( m_puhMergeIndex     , 0,                        m_uiNumPartition * sizeof( *m_puhMergeIndex ) );
 
-#if NH_3D_VSP
+#if NH_3D
   memset( m_piVSPFlag         , 0,                        m_uiNumPartition * sizeof( *m_piVSPFlag ) );
-#endif
-#if NH_3D_SPIVMP
   memset( m_pbSPIVMPFlag      , 0,                     m_uiNumPartition * sizeof( *m_pbSPIVMPFlag ) );   
-#endif
-#if NH_3D_SDC_INTRA
   memset( m_pbSDCFlag, false, m_uiNumPartition * sizeof( *m_pbSDCFlag ) );
-#endif
-#if NH_3D_DBBP
   memset( m_pbDBBPFlag , false, m_uiNumPartition * sizeof( *m_pbDBBPFlag ));
 #endif
@@ -624,10 +570,6 @@
   }
 
-#if NH_3D_ARP
+#if NH_3D
   memset( m_puhARPW      ,      0,        m_uiNumPartition * sizeof( *m_puhARPW )         );
-#endif
-
-
-#if NH_3D_DMM
   for( Int i = 0; i < NUM_DMM; i++ )
   {
@@ -635,8 +577,6 @@
     memset( m_dmmDeltaDC[i][1], 0,                        m_uiNumPartition * sizeof( *m_dmmDeltaDC[i][1] ) );
   }
-  memset( m_dmm1WedgeTabIdx,    0,                        m_uiNumPartition * sizeof( *m_dmm1WedgeTabIdx   ) );
-#endif
-#if NH_3D_SDC_INTRA
-    memset( m_pbSDCFlag,     false,                m_uiNumPartition * sizeof( *m_pbSDCFlag ) );
+    memset( m_dmm1WedgeTabIdx,    0,                        m_uiNumPartition * sizeof( *m_dmm1WedgeTabIdx   ) );
+    memset( m_pbSDCFlag      ,     false,                m_uiNumPartition * sizeof( *m_pbSDCFlag ) );
     memset( m_apSegmentDCOffset[0],     0,                m_uiNumPartition * sizeof( *m_apSegmentDCOffset[0] ) );
     memset( m_apSegmentDCOffset[1],     0,                m_uiNumPartition * sizeof( *m_apSegmentDCOffset[1] ) );
@@ -667,10 +607,4 @@
   m_pCtuAboveRight  = NULL;
 
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = NULL;
-  }
-
   UInt frameWidthInCtus = pcPic->getFrameWidthInCtus();
   if ( m_ctuRsAddr % frameWidthInCtus )
@@ -692,13 +626,4 @@
   {
     m_pCtuAboveRight = pcPic->getCtu( m_ctuRsAddr - frameWidthInCtus + 1 );
-  }
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    const RefPicList rpl=RefPicList(i);
-    if ( getSlice()->getNumRefIdx( rpl ) > 0 )
-    {
-      m_apcCUColocated[rpl] = getSlice()->getRefPic( rpl, 0)->getCtu( m_ctuRsAddr );
-    }
   }
 }
@@ -743,5 +668,5 @@
     }
     m_skipFlag[ui]      = false;
-#if NH_3D_DIS
+#if NH_3D
     m_bDISFlag[ui]      = false;
     m_ucDISType[ui]     = 0;
@@ -755,8 +680,6 @@
     m_pbMergeFlag[ui]   = 0;
     m_puhMergeIndex[ui] = 0;
-#if NH_3D_VSP
+#if NH_3D
     m_piVSPFlag[ui]     = 0;
-#endif
-#if NH_3D_SPIVMP
     m_pbSPIVMPFlag[ui] = 0;
 #endif
@@ -772,27 +695,17 @@
       m_puhCbf[comp][ui] = 0;
     }
-#if NH_3D_ARP
-      m_puhARPW[ui] = 0;
-#endif
-#if NH_3D_IC
-      m_pbICFlag[ui]  = false;
-#endif
-
-
-#if NH_3D_DMM
+#if NH_3D
+    m_puhARPW[ui] = 0;
+    m_pbICFlag[ui]  = false;
     for( Int i = 0; i < NUM_DMM; i++ )
     {
-      m_dmmDeltaDC[i][0] [ui] = 0;
-      m_dmmDeltaDC[i][1] [ui] = 0;
-    }
-    m_dmm1WedgeTabIdx    [ui] = 0;
-#endif
-#if NH_3D_SDC_INTRA
-      m_pbSDCFlag           [ui] = false;
-      m_apSegmentDCOffset[0][ui] = 0;
-      m_apSegmentDCOffset[1][ui] = 0;
-#endif
-#if NH_3D_DBBP
-      m_pbDBBPFlag[ui] = false;
+      m_dmmDeltaDC[i][0]  [ui] = 0;
+      m_dmmDeltaDC[i][1]  [ui] = 0;
+    }
+    m_dmm1WedgeTabIdx     [ui] = 0;
+    m_pbSDCFlag           [ui] = false;
+    m_apSegmentDCOffset[0][ui] = 0;
+    m_apSegmentDCOffset[1][ui] = 0;
+    m_pbDBBPFlag          [ui] = false;
 #endif
   }
@@ -849,8 +762,6 @@
   memset( m_pbMergeFlag,        0, iSizeInBool  );
   memset( m_puhMergeIndex,      0, iSizeInUchar );
-#if NH_3D_VSP
+#if NH_3D
   memset( m_piVSPFlag,          0, sizeof( SChar ) * m_uiNumPartition );
-#endif
-#if NH_3D_SPIVMP
   memset( m_pbSPIVMPFlag,       0, sizeof( Bool  ) * m_uiNumPartition );
 #endif
@@ -876,11 +787,7 @@
   memset( m_puhHeight,         uhHeight, iSizeInUchar );
   memset( m_pbIPCMFlag,        0, iSizeInBool  );
-#if NH_3D_ARP
+#if NH_3D
   memset( m_puhARPW,           0, iSizeInUchar  );
-#endif
-#if NH_3D_IC
   memset( m_pbICFlag,          0, iSizeInBool  );
-#endif
-#if NH_3D_DMM
   for( Int i = 0; i < NUM_DMM; i++ )
   {
@@ -889,11 +796,7 @@
   }
   memset( m_dmm1WedgeTabIdx,    0, sizeof(UInt) * m_uiNumPartition );
-#endif
-#if NH_3D_SDC_INTRA
   memset( m_pbSDCFlag,            0, sizeof(Bool) * m_uiNumPartition  );
   memset( m_apSegmentDCOffset[0], 0, sizeof(Pel) * m_uiNumPartition   );
   memset( m_apSegmentDCOffset[1], 0, sizeof(Pel) * m_uiNumPartition   );
-#endif
-#if NH_3D_DBBP
   memset( m_pbDBBPFlag,         0, sizeof(Bool) * m_uiNumPartition  );
 #endif
@@ -902,5 +805,5 @@
   {
     m_skipFlag[ui]   = false;
-#if NH_3D_DIS
+#if NH_3D
     m_bDISFlag[ui]   = false;
     m_ucDISType[ui]  = 0;
@@ -918,36 +821,22 @@
       m_apiMVPNum[rpl][ui] = -1;
     }
-#if NH_3D_DIS
-      m_bDISFlag[ui]    = pcCU->getDISFlag(uiPartOffset+ui);
-      m_ucDISType[ui]   = pcCU->getDISType(uiPartOffset+ui);
-#endif
-#if NH_3D_VSP
-    m_piVSPFlag[ui] = pcCU->m_piVSPFlag[uiPartOffset+ui];
-    m_pDvInfo[ ui ] = pcCU->m_pDvInfo[uiPartOffset+ui];
-#endif
-#if NH_3D_SPIVMP
-    m_pbSPIVMPFlag[ui]=pcCU->m_pbSPIVMPFlag[uiPartOffset+ui];
-#endif
-#if NH_3D_ARP
-      m_puhARPW           [ui] = pcCU->getARPW( uiPartOffset+ui );
-#endif
-#if NH_3D_IC
-      m_pbICFlag          [ui] = pcCU->m_pbICFlag[uiPartOffset+ui];
-#endif
-#if NH_3D_DMM
-  for( Int i = 0; i < NUM_DMM; i++ )
-  {
-    m_dmmDeltaDC[i][0] [ui] = pcCU->m_dmmDeltaDC[i][0] [uiPartOffset+ui];
-    m_dmmDeltaDC[i][1] [ui] = pcCU->m_dmmDeltaDC[i][1] [uiPartOffset+ui];
-  }
-  m_dmm1WedgeTabIdx    [ui] = pcCU->m_dmm1WedgeTabIdx  [uiPartOffset+ui];
-#endif
-#if NH_3D_SDC_INTRA
+#if NH_3D
+    m_bDISFlag    [ui] = pcCU->getDISFlag(uiPartOffset+ui);
+    m_ucDISType   [ui] = pcCU->getDISType(uiPartOffset+ui);
+    m_piVSPFlag   [ui] = pcCU->m_piVSPFlag[uiPartOffset+ui];
+    m_pDvInfo     [ui] = pcCU->m_pDvInfo[uiPartOffset+ui];
+    m_pbSPIVMPFlag[ui] = pcCU->m_pbSPIVMPFlag[uiPartOffset+ui];
+    m_puhARPW     [ui] = pcCU->getARPW( uiPartOffset+ui );
+    m_pbICFlag    [ui] = pcCU->m_pbICFlag[uiPartOffset+ui];
+    for( Int i = 0; i < NUM_DMM; i++ )
+    {
+      m_dmmDeltaDC[i][0] [ui] = pcCU->m_dmmDeltaDC[i][0] [uiPartOffset+ui];
+      m_dmmDeltaDC[i][1] [ui] = pcCU->m_dmmDeltaDC[i][1] [uiPartOffset+ui];
+    }
+    m_dmm1WedgeTabIdx    [ui] = pcCU->m_dmm1WedgeTabIdx  [uiPartOffset+ui];
     m_pbSDCFlag           [ui] = pcCU->m_pbSDCFlag            [ uiPartOffset + ui ];
     m_apSegmentDCOffset[0][ui] = pcCU->m_apSegmentDCOffset[0] [ uiPartOffset + ui ];
     m_apSegmentDCOffset[1][ui] = pcCU->m_apSegmentDCOffset[1] [ uiPartOffset + ui ];
-#endif
-#if NH_3D_DBBP
-      m_pbDBBPFlag[ui]=pcCU->m_pbDBBPFlag[uiPartOffset+ui];
+    m_pbDBBPFlag[ui]=pcCU->m_pbDBBPFlag[uiPartOffset+ui];
 #endif
   }
@@ -973,9 +862,4 @@
   m_pCtuAboveLeft   = pcCU->getCtuAboveLeft();
   m_pCtuAboveRight  = pcCU->getCtuAboveRight();
-
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i] = pcCU->getCUColocated(RefPicList(i));
-  }
 }
 
@@ -1009,5 +893,5 @@
 
   m_skipFlag=pcCU->getSkipFlag()          + uiPart;
-#if NH_3D_DIS
+#if NH_3D
   m_bDISFlag     = pcCU->getDISFlag()     + uiPart;
   m_ucDISType    = pcCU->getDISType()     + uiPart;
@@ -1019,20 +903,13 @@
   m_pePredMode=pcCU->getPredictionMode()  + uiPart;
   m_CUTransquantBypass  = pcCU->getCUTransquantBypass()+uiPart;
-#if NH_3D_NBDV
+#if NH_3D
   m_pDvInfo             = pcCU->getDvInfo()           + uiPart;
 #endif
-
   m_pbMergeFlag         = pcCU->getMergeFlag()        + uiPart;
   m_puhMergeIndex       = pcCU->getMergeIndex()       + uiPart;
-#if NH_3D_VSP
+#if NH_3D
   m_piVSPFlag           = pcCU->getVSPFlag()          + uiPart;
-#endif
-#if NH_3D_SPIVMP
-  m_pbSPIVMPFlag        = pcCU->getSPIVMPFlag()          + uiPart;
-#endif
-#if NH_3D_ARP
+  m_pbSPIVMPFlag        = pcCU->getSPIVMPFlag()       + uiPart;
   m_puhARPW             = pcCU->getARPW()             + uiPart;
-#endif
-#if NH_3D_IC
   m_pbICFlag            = pcCU->getICFlag()           + uiPart;
 #endif
@@ -1053,5 +930,5 @@
     m_explicitRdpcmMode[comp]             = pcCU->getExplicitRdpcmMode(ComponentID(comp))             + uiPart;
   }
-#if NH_3D_DMM
+#if NH_3D
   for( Int i = 0; i < NUM_DMM; i++ )
   {
@@ -1060,11 +937,7 @@
   }
   m_dmm1WedgeTabIdx    = pcCU->getDmm1WedgeTabIdx()  + uiPart;
-#endif
-#if NH_3D_SDC_INTRA
   m_pbSDCFlag               = pcCU->getSDCFlag()              + uiPart;
   m_apSegmentDCOffset[0]    = pcCU->getSDCSegmentDCOffset(0)  + uiPart;
   m_apSegmentDCOffset[1]    = pcCU->getSDCSegmentDCOffset(1)  + uiPart;
-#endif  
-#if NH_3D_DBBP
   m_pbDBBPFlag              = pcCU->getDBBPFlag()         + uiPart;
 #endif
@@ -1084,5 +957,4 @@
   {
     const RefPicList rpl=RefPicList(i);
-    m_apcCUColocated[rpl] = pcCU->getCUColocated(rpl);
     m_apiMVPIdx[rpl]=pcCU->getMVPIdx(rpl)  + uiPart;
     m_apiMVPNum[rpl]=pcCU->getMVPNum(rpl)  + uiPart;
@@ -1113,5 +985,5 @@
 }
 
-#if NH_3D_NBDV
+#if NH_3D
 Void TComDataCU::copyDVInfoFrom (TComDataCU* pcCU, UInt uiAbsPartIdx)
 {
@@ -1121,5 +993,5 @@
 
 // Copy inter prediction info from the biggest CU
-#if NH_3D_NBDV
+#if NH_3D
 Void TComDataCU::copyInterPredInfoFrom    ( TComDataCU* pcCU, UInt uiAbsPartIdx, RefPicList eRefPicList   , Bool bNBDV )
 #else
@@ -1141,11 +1013,7 @@
   m_pCtuLeft           = pcCU->getCtuLeft();
 
-  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
-  {
-    m_apcCUColocated[i]  = pcCU->getCUColocated(RefPicList(i));
-  }
 
   m_skipFlag           = pcCU->getSkipFlag ()             + uiAbsPartIdx;
-#if NH_3D_DIS
+#if NH_3D
   m_bDISFlag           = pcCU->getDISFlag ()              + uiAbsPartIdx;
   m_ucDISType          = pcCU->getDISType()               + uiAbsPartIdx;
@@ -1153,5 +1021,5 @@
 
   m_pePartSize         = pcCU->getPartitionSize ()        + uiAbsPartIdx;
-#if NH_3D_NBDV
+#if NH_3D
   if(bNBDV == true)
   {
@@ -1163,37 +1031,30 @@
   {
 #endif
-  m_pePredMode         = pcCU->getPredictionMode()        + uiAbsPartIdx;
-  m_ChromaQpAdj        = pcCU->getChromaQpAdj()           + uiAbsPartIdx;
-  m_CUTransquantBypass = pcCU->getCUTransquantBypass()    + uiAbsPartIdx;
-  m_puhInterDir        = pcCU->getInterDir      ()        + uiAbsPartIdx;
-
-  m_puhDepth           = pcCU->getDepth ()                + uiAbsPartIdx;
-  m_puhWidth           = pcCU->getWidth ()                + uiAbsPartIdx;
-  m_puhHeight          = pcCU->getHeight()                + uiAbsPartIdx;
-
-  m_pbMergeFlag        = pcCU->getMergeFlag()             + uiAbsPartIdx;
-  m_puhMergeIndex      = pcCU->getMergeIndex()            + uiAbsPartIdx;
-#if NH_3D_VSP
-  m_piVSPFlag          = pcCU->getVSPFlag()               + uiAbsPartIdx;
-  m_pDvInfo            = pcCU->getDvInfo()                + uiAbsPartIdx;
-#endif
-#if NH_3D_SPIVMP
-  m_pbSPIVMPFlag       = pcCU->getSPIVMPFlag()            + uiAbsPartIdx;
-#endif
-
-  m_apiMVPIdx[eRefPicList] = pcCU->getMVPIdx(eRefPicList) + uiAbsPartIdx;
-  m_apiMVPNum[eRefPicList] = pcCU->getMVPNum(eRefPicList) + uiAbsPartIdx;
-#if NH_3D_ARP
-  m_puhARPW            = pcCU->getARPW()                  + uiAbsPartIdx;
-#endif    
-#if NH_3D_DBBP
-  m_pbDBBPFlag       = pcCU->getDBBPFlag()              + uiAbsPartIdx;
-#endif
-
-  m_acCUMvField[ eRefPicList ].linkToWithOffset( pcCU->getCUMvField(eRefPicList), uiAbsPartIdx );
-#if NH_3D_NBDV
-  }
-#endif
-#if NH_3D_IC
+    m_pePredMode         = pcCU->getPredictionMode()        + uiAbsPartIdx;
+    m_ChromaQpAdj        = pcCU->getChromaQpAdj()           + uiAbsPartIdx;
+    m_CUTransquantBypass = pcCU->getCUTransquantBypass()    + uiAbsPartIdx;
+    m_puhInterDir        = pcCU->getInterDir      ()        + uiAbsPartIdx;
+
+    m_puhDepth           = pcCU->getDepth ()                + uiAbsPartIdx;
+    m_puhWidth           = pcCU->getWidth ()                + uiAbsPartIdx;
+    m_puhHeight          = pcCU->getHeight()                + uiAbsPartIdx;
+
+    m_pbMergeFlag        = pcCU->getMergeFlag()             + uiAbsPartIdx;
+    m_puhMergeIndex      = pcCU->getMergeIndex()            + uiAbsPartIdx;
+#if NH_3D
+    m_piVSPFlag          = pcCU->getVSPFlag()               + uiAbsPartIdx;
+    m_pDvInfo            = pcCU->getDvInfo()                + uiAbsPartIdx;
+    m_pbSPIVMPFlag       = pcCU->getSPIVMPFlag()            + uiAbsPartIdx;
+#endif
+    m_apiMVPIdx[eRefPicList] = pcCU->getMVPIdx(eRefPicList) + uiAbsPartIdx;
+    m_apiMVPNum[eRefPicList] = pcCU->getMVPNum(eRefPicList) + uiAbsPartIdx;
+#if NH_3D
+    m_puhARPW            = pcCU->getARPW()                  + uiAbsPartIdx;
+    m_pbDBBPFlag       = pcCU->getDBBPFlag()              + uiAbsPartIdx;
+#endif
+
+    m_acCUMvField[ eRefPicList ].linkToWithOffset( pcCU->getCUMvField(eRefPicList), uiAbsPartIdx );
+#if NH_3D
+  }
   m_pbICFlag           = pcCU->getICFlag()                + uiAbsPartIdx;
 #endif
@@ -1221,5 +1082,5 @@
   Int sizeInChar  = sizeof( SChar ) * uiNumPartition;
   memcpy( m_skipFlag   + uiOffset, pcCU->getSkipFlag(),       sizeof( *m_skipFlag )   * uiNumPartition );
-#if NH_3D_DIS
+#if NH_3D
   memcpy( m_bDISFlag   + uiOffset, pcCU->getDISFlag(),        sizeof( *m_bDISFlag )   * uiNumPartition );
   memcpy( m_ucDISType  + uiOffset, pcCU->getDISType(),        sizeof( *m_ucDISType )  * uiNumPartition);
@@ -1232,9 +1093,7 @@
   memcpy( m_pbMergeFlag         + uiOffset, pcCU->getMergeFlag(),         iSizeInBool  );
   memcpy( m_puhMergeIndex       + uiOffset, pcCU->getMergeIndex(),        iSizeInUchar );
-#if NH_3D_VSP
+#if NH_3D
   memcpy( m_piVSPFlag           + uiOffset, pcCU->getVSPFlag(),           sizeof( SChar ) * uiNumPartition );
   memcpy( m_pDvInfo             + uiOffset, pcCU->getDvInfo(),            sizeof( *m_pDvInfo ) * uiNumPartition );
-#endif
-#if NH_3D_SPIVMP  || NH_3D_DBBP
   memcpy( m_pbSPIVMPFlag        + uiOffset, pcCU->getSPIVMPFlag(),        sizeof( Bool ) * uiNumPartition );
 #endif
@@ -1255,5 +1114,5 @@
     memcpy( m_explicitRdpcmMode[comp]             + uiOffset, pcCU->getExplicitRdpcmMode(ComponentID(comp))            , iSizeInUchar );
   }
-#if NH_3D_DMM
+#if NH_3D
   for( Int i = 0; i < NUM_DMM; i++ )
   {
@@ -1262,14 +1121,8 @@
   }
   memcpy( m_dmm1WedgeTabIdx    + uiOffset, pcCU->getDmm1WedgeTabIdx(),         sizeof(UInt) * uiNumPartition );
-#endif
-#if NH_3D_SDC_INTRA
   memcpy( m_pbSDCFlag             + uiOffset, pcCU->getSDCFlag(), sizeof( *m_pbSDCFlag ) * uiNumPartition  );
   memcpy( m_apSegmentDCOffset[0]  + uiOffset, pcCU->getSDCSegmentDCOffset(0), sizeof( Pel ) * uiNumPartition);
   memcpy( m_apSegmentDCOffset[1]  + uiOffset, pcCU->getSDCSegmentDCOffset(1), sizeof( Pel ) * uiNumPartition);
-#endif
-#if NH_3D_DBBP
   memcpy( m_pbDBBPFlag          + uiOffset, pcCU->getDBBPFlag(),          iSizeInBool  );
-#endif
-#if NH_3D_ARP
   memcpy( m_puhARPW             + uiOffset, pcCU->getARPW(),              iSizeInUchar );
 #endif
@@ -1291,5 +1144,4 @@
     memcpy( m_apiMVPIdx[rpl] + uiOffset, pcCU->getMVPIdx(rpl), iSizeInUchar );
     memcpy( m_apiMVPNum[rpl] + uiOffset, pcCU->getMVPNum(rpl), iSizeInUchar );
-    m_apcCUColocated[rpl] = pcCU->getCUColocated(rpl);
   }
 
@@ -1314,5 +1166,5 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   memcpy( m_pbICFlag            + uiOffset, pcCU->getICFlag(),            iSizeInBool );
 #endif
@@ -1338,5 +1190,5 @@
 
   memcpy( pCtu->getSkipFlag() + m_absZIdxInCtu, m_skipFlag, sizeof( *m_skipFlag ) * m_uiNumPartition );
-#if NH_3D_DIS
+#if NH_3D
   memcpy( pCtu->getDISFlag()  + m_absZIdxInCtu, m_bDISFlag, sizeof( *m_bDISFlag )  * m_uiNumPartition );
   memcpy( pCtu->getDISType()  + m_absZIdxInCtu, m_ucDISType, sizeof( *m_ucDISType ) * m_uiNumPartition );
@@ -1344,5 +1196,5 @@
 
   memcpy( pCtu->getQP() + m_absZIdxInCtu, m_phQP, sizeInChar  );
-#if NH_3D_NBDV
+#if NH_3D
   memcpy( pCtu->getDvInfo() + m_absZIdxInCtu, m_pDvInfo, sizeof(* m_pDvInfo) * m_uiNumPartition );
 #endif
@@ -1354,15 +1206,11 @@
   memcpy( pCtu->getMergeFlag()         + m_absZIdxInCtu, m_pbMergeFlag,         iSizeInBool  );
   memcpy( pCtu->getMergeIndex()        + m_absZIdxInCtu, m_puhMergeIndex,       iSizeInUchar );
-#if NH_3D_VSP
+#if NH_3D
   memcpy( pCtu->getVSPFlag()           + m_absZIdxInCtu, m_piVSPFlag,           sizeof( SChar ) * m_uiNumPartition );
-#endif
-#if NH_3D_DBBP
   memcpy( pCtu->getDvInfo()            + m_absZIdxInCtu, m_pDvInfo,             sizeof( *m_pDvInfo ) * m_uiNumPartition );
-#endif
-#if NH_3D_SPIVMP
   memcpy( pCtu->getSPIVMPFlag()        + m_absZIdxInCtu, m_pbSPIVMPFlag,        sizeof( Bool ) * m_uiNumPartition );
 #endif
 
-for (UInt ch=0; ch<numValidChan; ch++)
+  for (UInt ch=0; ch<numValidChan; ch++)
   {
     memcpy( pCtu->getIntraDir(ChannelType(ch)) + m_absZIdxInCtu, m_puhIntraDir[ch], iSizeInUchar);
@@ -1380,5 +1228,5 @@
   }
 
-#if NH_3D_DMM
+#if NH_3D
   for( Int i = 0; i < NUM_DMM; i++ )
   {
@@ -1386,15 +1234,10 @@
     memcpy( pCtu->getDmmDeltaDC( (DmmID)i, 1 ) + m_absZIdxInCtu, m_dmmDeltaDC[i][1], sizeof(Pel ) * m_uiNumPartition );
   }
+
   memcpy( pCtu->getDmm1WedgeTabIdx()           + m_absZIdxInCtu, m_dmm1WedgeTabIdx,  sizeof(UInt) * m_uiNumPartition );
-#endif
-#if NH_3D_SDC_INTRA
   memcpy( pCtu->getSDCFlag()             + m_absZIdxInCtu, m_pbSDCFlag, sizeof(Bool) * m_uiNumPartition );
   memcpy( pCtu->getSDCSegmentDCOffset(0) + m_absZIdxInCtu, m_apSegmentDCOffset[0], sizeof( Pel ) * m_uiNumPartition);
   memcpy( pCtu->getSDCSegmentDCOffset(1) + m_absZIdxInCtu, m_apSegmentDCOffset[1], sizeof( Pel ) * m_uiNumPartition);
-#endif
-#if NH_3D_DBBP
   memcpy( pCtu->getDBBPFlag()          + m_absZIdxInCtu, m_pbDBBPFlag,          iSizeInBool  );
-#endif
-#if NH_3D_ARP
   memcpy( pCtu->getARPW()              + m_absZIdxInCtu, m_puhARPW,             iSizeInUchar );
 #endif
@@ -1432,14 +1275,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   memcpy( pCtu->getICFlag() + m_absZIdxInCtu, m_pbICFlag, sizeof( *m_pbICFlag ) * m_uiNumPartition );
 #endif
   pCtu->getTotalBins() = m_uiTotalBins;
 }
-#if H_3D_SPIVMP
-  memcpy( rpcCU->getSPIVMPFlag()        + uiPartOffset, m_pbSPIVMPFlag,        sizeof(Bool) * uiQNumPart );
-#endif
-
-
 
 // --------------------------------------------------------------------------------------------------------------------
@@ -1786,5 +1624,5 @@
 Bool TComDataCU::isLosslessCoded(UInt absPartIdx) const
 {
-  return (getSlice()->getPPS()->getTransquantBypassEnableFlag() && getCUTransquantBypass (absPartIdx));
+  return (getSlice()->getPPS()->getTransquantBypassEnabledFlag() && getCUTransquantBypass (absPartIdx));
 }
 
@@ -1842,5 +1680,5 @@
   }
   iLeftIntraDir  = pcCULeft ? ( pcCULeft->isIntra( LeftPartIdx ) ? pcCULeft->getIntraDir( chType, LeftPartIdx ) : DC_IDX ) : DC_IDX;
-#if NH_3D_DMM
+#if NH_3D
   mapDmmToIntraDir( iLeftIntraDir );
 #endif
@@ -1854,5 +1692,5 @@
   }
   iAboveIntraDir = pcCUAbove ? ( pcCUAbove->isIntra( AbovePartIdx ) ? pcCUAbove->getIntraDir( chType, AbovePartIdx ) : DC_IDX ) : DC_IDX;
-#if NH_3D_DMM
+#if NH_3D
   mapDmmToIntraDir( iAboveIntraDir );
 #endif
@@ -1990,5 +1828,5 @@
   return uiCtx;
 }
-#if NH_3D_ARP
+#if NH_3D
 UInt TComDataCU::getCTXARPWFlag( UInt uiAbsPartIdx )
 {
@@ -2001,6 +1839,5 @@
   return uiCtx;
 }
-#endif
-#if NH_3D_DBBP
+
 Pel* TComDataCU::getVirtualDepthBlock(UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, UInt& uiDepthStride)
 {
@@ -2016,18 +1853,4 @@
   assert( !getSlice()->getIsDepth() );
   
-#if H_3D_FCO
-  TComPic* depthPic = getSlice()->getIvPic(true, getSlice()->getViewIndex() );
-  
-  if( depthPic && depthPic->getPicYuvRec() != NULL && depthPic->getIsDepth() )  // depth first
-  {
-    depthPicYuv = depthPic->getPicYuvRec();
-    depthPicYuv->extendPicBorder();
-    
-    // get collocated depth block for current CU
-    uiDepthStride = depthPicYuv->getStride();
-    pDepthPels    = depthPicYuv->getLumaAddr( getAddr(), uiAbsPartIdx );
-  }
-  else  // texture first
-#else
   {
     DisInfo DvInfo = getDvInfo(uiAbsPartIdx);
@@ -2052,7 +1875,5 @@
     
     Bool depthRefineFlag = false;
-#if NH_3D_NBDV_REF
     depthRefineFlag = m_pcSlice->getDepthRefinementFlag();
-#endif // NH_3D_NBDV_REF
     
     TComMv cDv = depthRefineFlag ? DvInfo.m_acDoNBDV : DvInfo.m_acNBDV;
@@ -2067,5 +1888,4 @@
     pDepthPels = depthPicYuv->getAddr(COMPONENT_Y) + depthPosX + depthPosY * uiDepthStride;
   }
-#endif
   
   AOF( depthPicYuv != NULL );
@@ -2075,7 +1895,5 @@
   return pDepthPels;
 }
-#endif
-
-#if NH_3D_DBBP
+
 Void TComDataCU::setDBBPFlagSubParts ( Bool bDBBPFlag, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
 {
@@ -2170,5 +1988,5 @@
 }
 
-#if NH_3D_DIS
+#if NH_3D
 Void TComDataCU::setDISFlagSubParts( Bool bDIS, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -2336,5 +2154,5 @@
 }
 
-#if NH_3D_SDC_INTRA
+#if NH_3D
 Void TComDataCU::setSDCFlagSubParts ( Bool bSDCFlag, UInt absPartIdx, UInt depth )
 {
@@ -2349,7 +2167,5 @@
     UInt lumaPredMode = getIntraDir( CHANNEL_TYPE_LUMA, uiAbsPartIdx );
     if( lumaPredMode < NUM_INTRA_MODE ) { return true; }
-#if NH_3D_DMM
     if( isDmmMode( lumaPredMode )     ) { return true; }
-#endif
   }
   return false;
@@ -2367,12 +2183,10 @@
 }
 
-#if NH_3D_SPIVMP
+#if NH_3D
 Void TComDataCU::setSPIVMPFlagSubParts( Bool bSPIVMPFlag, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
 {
   setSubPart<Bool>( bSPIVMPFlag, m_pbSPIVMPFlag, uiAbsPartIdx, uiDepth, uiPartIdx );
 }
-#endif
-
-#if NH_3D_VSP
+
 Void TComDataCU::setVSPFlagSubParts( SChar iVSPFlag, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
 {
@@ -2599,5 +2413,5 @@
 
 // This is for use by a leaf/sub CU object only, with no additional AbsPartIdx
-#if NH_3D_IC || NH_3D_VSP
+#if NH_3D
 Void TComDataCU::getPartIndexAndSize( UInt uiPartIdx, UInt& ruiPartAddr, Int& riWidth, Int& riHeight, UInt uiAbsPartIdx, Bool bLCU) const
 {
@@ -2941,7 +2755,5 @@
     );
 }
-#endif
-
-#if NH_3D_VSP
+
 /** Add a VSP merging candidate
  * \Inputs
@@ -2997,7 +2809,5 @@
         predFlag[iRefListIdX] = 1;
         mvVSP[0+iRefListIdX].setMvField( pDInfo->m_acNBDV, i );
-#if NH_3D_NBDV
         mvVSP[0+iRefListIdX].getMv().setIDVFlag (false);
-#endif
       }
     }
@@ -3005,9 +2815,5 @@
 
   dirVSP = (predFlag[0] | (predFlag[1] << 1));
-  m_mergCands[MRG_VSP].setCand( mvVSP, dirVSP, true
-#if NH_3D_SPIVMP
-    , false
-#endif
-    );
+  m_mergCands[MRG_VSP].setCand( mvVSP, dirVSP, true    , false);
   if ( mrgCandIdx == iCount )
   {
@@ -3019,7 +2825,5 @@
   return false;
 }
-#endif
-
-#if NH_3D_IV_MERGE
+
 inline Bool TComDataCU::xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Int* ivCandDir, TComMv* ivCandMv, Int* ivCandRefIdx )
 {
@@ -3052,5 +2856,4 @@
       if(!bRemove)
       {
-#if NH_3D_NBDV
         if(iLoop) // For IvMcShift candidate
         {
@@ -3058,5 +2861,4 @@
           tmpMV[1].getMv().setIDVFlag (false);
         }
-#endif
         m_mergCands[MRG_IVSHIFT].setCand(tmpMV, tmpDir, false, false);
         if( mrgCandIdx == iCount )
@@ -3072,6 +2874,4 @@
 } 
 
-#endif
-#if NH_3D_MLC
 /** Construct a extended list of merging candidates
  * \param pcMvFieldNeighbours
@@ -3081,13 +2881,5 @@
  * \param numValidMergeCand
  */
-Void TComDataCU::buildMCL(TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours
-#if NH_3D_VSP
-  , Int* vspFlag
-#endif
-#if NH_3D_SPIVMP
-  , Bool* pbSPIVMPFlag
-#endif
-  , Int& numValidMergeCand
-  )
+Void TComDataCU::buildMCL(TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag  , Bool* pbSPIVMPFlag  , Int& numValidMergeCand  )
 {
   if (!( getSlice()->getIsDepth() || getSlice()->getViewIndex()>0))
@@ -3095,5 +2887,4 @@
     return;
   }
-
 
 #if ENC_DEC_TRACE && NH_MV_ENC_DEC_TRAC
@@ -3119,7 +2910,5 @@
     extMergeCandList[ui<<1].setMvField(cZeroMv, NOT_VALID);
     extMergeCandList[(ui<<1)+1].setMvField(cZeroMv, NOT_VALID);
-#if NH_3D_VSP
     vspFlag[ui] = 0;
-#endif
   }
 
@@ -3129,12 +2918,5 @@
     if (m_mergCands[i].m_bAvailable)
     {
-      m_mergCands[i].getCand(iCount, extMergeCandList, uhInterDirNeighboursExt
-#if NH_3D_VSP
-        , vspFlag
-#endif
-#if NH_3D_SPIVMP
-        , pbSPIVMPFlag
-#endif
-        );
+      m_mergCands[i].getCand(iCount, extMergeCandList, uhInterDirNeighboursExt, vspFlag, pbSPIVMPFlag );
       iCount++;
       if (iCount >= getSlice()->getMaxNumMergeCand())
@@ -3229,26 +3011,15 @@
  * \param numValidMergeCand
  */
-Void TComDataCU::xGetInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours
-#if NH_3D_SPIVMP
-      , TComMvField* pcMvFieldSP, UChar* puhInterDirSP
-#endif
-      , Int& numValidMergeCand, Int mrgCandIdx
-)
-{
-#if NH_3D_IV_MERGE
+
+Void TComDataCU::xGetInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, TComMvField* pcMvFieldSP, UChar* puhInterDirSP, Int& numValidMergeCand, Int mrgCandIdx )
+{
   TComMv cZeroMv;
   TComMvField tmpMV[2];  
-#endif
 
   //////////////////////////////////
   //////// GET DISPARITIES  ////////
   //////////////////////////////////
-#if NH_3D_IV_MERGE
   DisInfo cDisInfo = getDvInfo(uiAbsPartIdx);
   m_cDefaultDisInfo = cDisInfo;
-#elif NH_3D_VSP
-  // for xAddVspCand()
-  DisInfo cDisInfo = getDvInfo(uiAbsPartIdx);
-#endif
 
   if (!( getSlice()->getIsDepth() || getSlice()->getViewIndex()>0))
@@ -3268,24 +3039,13 @@
   deriveLeftRightTopIdxGeneral( uiAbsPartIdx, uiPUIdx, uiPartIdxLT, uiPartIdxRT );
   deriveLeftBottomIdxGeneral  ( uiAbsPartIdx, uiPUIdx, uiPartIdxLB );
-#if NH_3D_TEXT_MERGE
   Bool bMPIFlag   = getSlice()->getMpiFlag(); 
   Int  tmpDir;
-#endif 
-#if NH_3D_IV_MERGE || NH_3D_TEXT_MERGE
   Bool bIsDepth = getSlice()->getIsDepth();
-#endif
-
-#if NH_3D_IC
+
   Bool bICFlag = getICFlag(uiAbsPartIdx);
-#endif
-#if NH_3D_ARP
   Bool bARPFlag = getARPW(uiAbsPartIdx) > 0;
-#endif
-#if NH_3D_DBBP
   Bool bDBBPFlag = getDBBPFlag(uiAbsPartIdx);
   assert(bDBBPFlag == getDBBPFlag(0));  
-#endif
-
-#if NH_3D_NBDV
+
   for(Int i = 0; i < MRG_MAX_NUM_CANDS_MEM; i++)  
   {
@@ -3293,5 +3053,4 @@
     pcMFieldNeighbours[(i<<1)+1].getMv().setIDVFlag (false);
   }
-#endif
   // init containers
   for (Int i = 0; i<MRG_IVSHIFT+1; i++)
